// $Id$
//
// Copyright (C) 2006 VeriSign, Inc.

package se.rfc.unbound.stub;

import org.xbill.DNS.Flags;
import org.xbill.DNS.Name;

import se.rfc.unbound.AbstractResolver;
import se.rfc.unbound.DNSEvent;
import se.rfc.unbound.Request;
import se.rfc.unbound.Resolver;
import se.rfc.unbound.Response;

public class StubResolverHead extends AbstractResolver
{

  public StubResolverHead(Resolver nextResolver)
  {
    super(nextResolver);
  }

  public void processRequest(DNSEvent event)
  {
    Request request = event.getRequest();
    request.setFlag(Flags.RD);
    
    mNextResolver.processRequest(event);
  }

  public void processResponse(DNSEvent event)
  {
    // do nothing;
  }

  public Response query(Name qname, int qtype, int qclass)
  {
    Request request = new Request(qname, qtype, qclass);
    DNSEvent event = new DNSEvent(request);
    
    // This should synchronously process the request, based on the way the
    // resolver tail is configured.
    processRequest(event);
    
    return event.getResponse();
  }
}
